$UmcUser = "symplified\umcadmin" #<---Enter the UMC user name with permission to generate a token!
$UmcPassword = "Symc4now!" #<---Enter the password for the user above!
$UmcHostname = "10.10.2.81"#<---Enter the hostname for the SEPM hosting UMC!
$AccessTokenXml = '.\AccessToken.xml'#<--- This is where we save the token so you can use it outside of this script.
$TokenExpiryXml = '.\TokenExpiry.xml'#<--- This is where we save the token used by date.
function GenerateToken #<--- this is what actually generates the token!
	{$URI = "https://" + $UmcHostname + ":8443/umcservices/rest/v1.0/auth/token" #<--- Token generation URL of the UMC
	$Body = ConvertTo-Json @{username= $UmcUser; password= $UmcPassword} #<--- Building the credentials up in JSON format
	$UmcToken = Invoke-RestMethod $URI -ContentType application/json -Body $Body -Method Post #<--- Generation of the token
	$AccessToken = $UmcToken.accessToken #<--- The actual token
	$TokenExpiry = (Get-Date).AddSeconds($UmcToken.expiresIn)#<--- Working out when the token expires for later use.
	Write-Host "Token: $AccessToken"
	Write-Host "Valid until: $TokenExpiry"
	$AccessToken | Export-Clixml $AccessTokenXml #<--- Here we pop the token into an XML file for later use
	$TokenExpiry | Export-Clixml $TokenExpiryXml #<--- Same for the expiry date of the token
	}
	
If
	((Test-Path $AccessTokenXml) -and (Test-Path $TokenExpiryXml)) #<--- First we check if we've saved the token and expiry date in xml before
    {$TokenExpiry = (Import-Clixml $TokenExpiryXml)#<--- If we have, we'll import the expiry date to check if it's lapsed
	If
		($TokenExpiry -le $(Get-Date)){Write-Host "Token expired: Generating new token" #<--- That token is expired. Gross!
		GenerateToken}

    else {$AccessToken = (Import-Clixml $AccessTokenXml)#<--- Token is still fresh. Let's pull it out of the XML and make it available in $AccessToken
	Write-Host "Existing token $AccessToken valid until $TokenExpiry"}
    }
else {"No token found: Generating token" #<--- No XML found so let's generate from scratch.
GenerateToken}